import 'package:analyzer/dart/element/element.dart';

/// call `throwError` if the condition result  is false
void throwIf(bool condition, String message, {Element? element}) {
  if (condition) throwError(message, element: element);
}

///
void throwError(String message, {Element? element}) {
  throw InvalidGenerationSourceError(
    message,
    element: element,
  );
}

/// class to define an error in code generation
class InvalidGenerationSourceError implements Exception {
  /// error message
  final String message;

  /// element that cause an error
  final Element? element;

  const InvalidGenerationSourceError(this.message, {this.element});

  @override
  String toString() =>
      '[ERROR] $message ${element != null ? 'in $element' : ''}';
}
